var Evika_1 = new Evika("Evika_amati","Evika page","Evika FileSystem");

function Evika(DeviceName,Page,FSPage)
{
   var AutoRequestPeriod = 1000;
   
   var DEVICE = IR.GetDevice(DeviceName);
   var VolumeLevel = IR.GetVariable("Drivers."+DeviceName+".Amati_Volume level");
   var HoursTotal, MinutesTotal, SecondsTotal, TimeTotal;
   var TrackTimeTotal = "";
   var HoursPlayed, MinutesPlayed, SecondsPlayed, TimeElapsed;
   var TrackTimeElapsed = "";
   var TrackTimeProgress;   
   var TrackTimeSeek;
   var SongID, NextSongID;
   var tokenPL1 = tokenPL2 = 0;
   var PlaylistLength;
   var PlaylistArray = [];
   var FilesystemLength;
   var FilesystemArray = [];
   
   
   
   //Инициализация переменных
   IR.SetVariable("Drivers."+DeviceName+".Amati_Volume",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_State",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track time elapsed","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track time total","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track time progress",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track genre","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track album","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track album artist","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track file","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Track title","");
   IR.SetVariable("Drivers."+DeviceName+".Amati_Playlist length",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Next song ID",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Random",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Current song ID",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Mute",0);
   IR.SetVariable("Drivers."+DeviceName+".Amati_Filesystem length",0);
   
   
   
   //Инициализация списка песен
   IR.GetItem(Page).CreateItem(IR.ITEM_LISTBOX,"List 1", 310, 300, 370, 400);             
   var List_1 = IR.GetItem(Page).GetItem("List 1");
   List_1.Direction = 0; //Вертикально
   List_1.Template = "Evika Playlist Template";   // Прикрепляем шаблон к созданному листу
   
   IR.GetItem(FSPage).CreateItem(IR.ITEM_LISTBOX,"List 1", 10, 84, 370, 400);             
   var List_2 = IR.GetItem(FSPage).GetItem("List 1");
   List_2.Direction = 0; //Вертикально
   List_2.Template = "Evika Playlist Template";   // Прикрепляем шаблон к созданному листу
   
   
   //Запрос обратной связи
   IR.SetInterval(AutoRequestPeriod,AutoRequest);
   IR.SetInterval(3*AutoRequestPeriod,AutoRequestPlaylist);
   
   //Функция запроса статуса
   function AutoRequest() //Запрос данных текущей песни
   {
      DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=status&param=null']);
   } 
   function AutoRequestPlaylist() //Запрос данных текущего плей листа
   {
      DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=playlistinfo&param=null']);
   } 

   function AutoRequestFTP()  //Запрос данных состава файловой системы на ftp
   {
      DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=lsinfo&param=ftp-music']);
   }

   function TimeConvert(seconds)
   {
      var hours = Math.floor(seconds / 3600);
      var minutes = Math.floor((seconds - hours*3600) / 60);
      var seconds2 = seconds - hours*3600 - minutes*60;
            if(minutes < 10)
               minutes = "0" + minutes;
            if(seconds2 < 10)
               seconds2 = "0" + seconds2;
      var time = hours + ":" + minutes + ":" + seconds2;
      return time;
   }

//=======================================================
//======= Формирование списка песен и работа с ним ======
//=======================================================         
   function CheckPT()  //При изменении длины плейлиста формируем новый список элементов и выводим его 
   {
      tokenPL1 = tokenPL2; //Запоминаем старое значение
      //IR.Log("tokenPL1 = " + tokenPL1);
      tokenPL2 = PlaylistLength;  //Записываем новое значение
      //IR.Log("tokenPL2 = " + tokenPL2);
      if(tokenPL1 != tokenPL2)
      {
         List_1.Clear();
         for(i=0;i<PlaylistLength;i++)
         {
            // Массив [[АРТИСТ][НАЗВАНИЕ ПЕСНИ][АЛЬБОМ][ДЛИТЕЛЬНОСТЬ ПЕСНИ][ПОЗИЦИЯ В СПИСКЕ][ID]]
            List_1.CreateItem(PlaylistArray[6*i+5], 2, {Text: PlaylistArray[6*i+1]});  //Название песни  
            List_1.CreateItem(PlaylistArray[6*i+5], 1, {Text: PlaylistArray[6*i]});    //Артист
            List_1.CreateItem(PlaylistArray[6*i+5], 5, {Text: TimeConvert(PlaylistArray[6*i+3])});    //Длительность
            List_1.CreateItem(PlaylistArray[6*i+5], 6, {Text: "P:" + PlaylistArray[6*i+4] + " ID:" + PlaylistArray[6*i+5]}); //Позиция в плейлисте и Идентификатор в файловой системе
         }
      }   
   }
   IR.SetInterval(5000,CheckPT);
   
   function DrawFS()  //При изменении длины плейлиста формируем новый список элементов и выводим его 
   {
      List_2.Clear();
      for(i=0;i<FilesystemLength;i++)
      {
            // Массив [[АРТИСТ][НАЗВАНИЕ ПЕСНИ][АЛЬБОМ][ДЛИТЕЛЬНОСТЬ ПЕСНИ][ПОЗИЦИЯ В СПИСКЕ][ID]]
            List_2.CreateItem(i, 2, {Text: FilesystemArray[i]});  //Название песни  
      }
   }
   
   
   
   //Запуск песни из плейлиста
   IR.AddListener(IR.EVENT_ITEM_SELECT, List_1, function(Item, Subitem)
   {
      IR.Log("Item = " + Item + "; Subitem = " + Subitem);
      if(Subitem == 2)        //Кнопка Play
         DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=action&param={"action":"play","type":"current","arg":',Item.toString(),'}']);  
      if(Subitem == 3)        //Кнопка Delete song
         DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=action&param={"action":"remove","type":"current","arg":',Item.toString(),'}']);   
   });
   
   //Обработка внешней ссылки
   IR.AddListener(IR.EVENT_ITEM_PRESS, IR.GetItem("Evika Add Station").GetItem("Item 3"), function()
   {
      var name = IR.GetItem("Evika Add Station").GetItem("Item 1").Text;
      var link = IR.GetItem("Evika Add Station").GetItem("Item 2").Text;
      DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=radio-add&param=["',name,'","',link,'"]']);
   });
      
//==================================================================================
//==================================================================================
//==================================================================================
//==================================================================================
//================================================================================== 
//==================================================================================
//==================================================================================    
   //Получение данных из GUI и отправка оборудованию
   IR.AddListener(IR.EVENT_CHANNEL_SET, IR.GetDevice(DeviceName), function(name, value)
   {
      //Получение данных из GUI     
      switch(name)
      {
         case "Amati_Volume set": //В данную переменную передавать значение Value элемента (уровня)           
            DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=set_vol&param=',value.toString()]);
            break;
      }
  
      //навигация по прогрессу трека
      switch(name)
      {
         case "Amati_Seek": //В данную переменную передавать значение Value элемента (уровня)
            TrackTimeSeek = Math.floor(value * TimeTotal / 100);
            IR.Log("TrackTimeSeek = " + TrackTimeSeek);           
            DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=seekid&param=[' + SongID.toString() + ',' + TrackTimeSeek + ']']);
            break;       //["1",1058]
      }
      
      //Включение рандома
      switch(name)
      {
         case "Amati_Set random": //В данную переменную передавать значение Value элемента (уровня)
            if(value == 1)
               DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=set_random&param=true']);
            else if(value == 0)
               DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=set_random&param=false']);
            break;
      }

      //Mute
      switch(name)
      {
         case "Amati_Mute": //В данную переменную передавать значение Value элемента (уровня)
            if(value == 1)
               DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=set-mute&param=1']);
            else if(value == 0)
               DEVICE.Send(['POST,/cgi-bin/audio/request.cgi,request=cmd&cmd=set-mute&param=0']);
            break;
      }
      
      //Обновление списка ftp
      switch(name)
      {
         case "Amati_Refresh FS": //В данную переменную передавать значение Value элемента (уровня)
            AutoRequestFTP();
            //IR.Log("Запрос на устройство отправлен");
            IR.SetInterval(3000,DrawFS);
            break;
      }
            
             
   });

//==================================================================================
//==================================================================================
//==================================================================================
//==================================================================================
//================================================================================== 
//==================================================================================
//==================================================================================    
   //Получение данных от оборудования и запись обратной связи
   IR.AddListener(IR.EVENT_RECEIVE_TEXT, DEVICE, function(inText)
   {
      var JSONObjectTemp = JSON.Parse(inText);
      var JSONObjectLength = JSONObjectTemp.length;
      if (JSONObjectTemp.state) 
      {
//==================================================================================
//==================================================================================
//==================================================================================
//========= ОбРАбОТКА ДАННЫХ ПЕСНИ =================================================
//================================================================================== 
//==================================================================================
//==================================================================================    
         //IR.Log("Данные песни");
         var JSONObject = JSONObjectTemp;

//==================================================================================      
         //Проверка и запись уровня громкости
         if((JSONObject.volume >= 0)&&(JSONObject.volume <= 100))
         { 
            //IR.Log("Volume = "+JSONObject.volume);
            IR.SetVariable("Drivers."+DeviceName+".Amati_Volume",parseFloat(JSONObject.volume));
         }
         
         //Mute
         var Mute = JSONObject.mute;
         //IR.Log("Mute = " + Mute);
//==================================================================================      
         //Проверка статуса включения
         if(JSONObject.state == "play")
         { 
            //IR.Log("State play = " + JSONObject.state);
            IR.SetVariable("Drivers."+DeviceName+".Amati_State",1);
         }
         else if((JSONObject.state == "stop")||(JSONObject.state == "pause"))
         { 
            //IR.Log("State stop or pause= " + JSONObject.state);
            IR.SetVariable("Drivers."+DeviceName+".Amati_State",0);
         }
//==================================================================================
         //Проверка проигранного времени
         TimeElapsed = Math.floor(JSONObject.elapsed);
         if (TimeElapsed >= 0)
         {
            var x = TimeConvert(TimeElapsed);
            IR.SetVariable("Drivers."+DeviceName+".Amati_Track time elapsed",x);
            //IR.Log("Проиграно = " + x);
         }   
//==================================================================================      
         //Проверка длительности трека
         TimeTotal = Math.floor(JSONObject.songdata.Time);
         if (TimeTotal >= 0)
         {
            var x = TimeConvert(TimeTotal);
            IR.SetVariable("Drivers."+DeviceName+".Amati_Track time total",x);
            //IR.Log("Общее время трека = " + x);
         }
//==================================================================================      
         //Вычисление прогресса трека
         TrackTimeProgress = Math.floor(100 * TimeElapsed / TimeTotal);
         IR.SetVariable("Drivers."+DeviceName+".Amati_Track time progress",TrackTimeProgress);
         //IR.Log("TrackTimeProgress = " + TrackTimeProgress + "%");
//==================================================================================
         //Получение номера текущего трека
         SongID = JSONObject.songid;
         IR.SetVariable("Drivers."+DeviceName+".Amati_Current song ID",SongID);
         
         NextSongID = JSONObject.nextsong;
      
         //Данные песни
         if(JSONObject.songdata.Genre)
            var TrackGenre = JSONObject.songdata.Genre;
         else
            var TrackGenre = "Неизвестный жанр"; 
         IR.SetVariable("Drivers."+DeviceName+".Amati_Track genre",TrackGenre);
      
         if(JSONObject.songdata.Album)
            var TrackAlbum = JSONObject.songdata.Album;
         else
            var TrackAlbum = "Неизвестный альбом";   
         IR.SetVariable("Drivers."+DeviceName+".Amati_Track album",TrackAlbum);
      
         var TrackFile = JSONObject.songdata.file;
         IR.SetVariable("Drivers."+DeviceName+".Amati_Track file",TrackFile);
      
         var TrackTitle = JSONObject.songdata.Title;
         IR.SetVariable("Drivers."+DeviceName+".Amati_Track title",TrackTitle);
      
         if(JSONObject.songdata.AlbumArtist)
         {
            var TrackAlbumArtist = JSONObject.songdata.AlbumArtist;
            IR.SetVariable("Global.ArtistName",TrackAlbumArtist);
         }   
         else
         {
            var TrackAlbumArtist = "Неизвестный артист";
            var TrackTitlePart = TrackTitle.slice(0,TrackTitle.indexOf("-",0)-1);
            //IR.Log(TrackTitlePart);
            IR.SetVariable("Global.ArtistName",TrackTitlePart);
         }
         IR.SetVariable("Drivers."+DeviceName+".Amati_Track album artist",TrackAlbumArtist);
         
         //IR.Log("Global.ArtistName ======= " + IR.GetVariable("Global.ArtistName"));

//==================================================================================      
         var NextSongID = JSONObject.nextsongid;
         IR.SetVariable("Drivers."+DeviceName+".Amati_Next song ID",NextSongID);
        
         var Random = JSONObject.random;
         IR.SetVariable("Drivers."+DeviceName+".Amati_Random",Random);
      } 
      else if(JSONObjectTemp[0].Id)
      {
//==================================================================================
//==================================================================================
//==================================================================================
//========= ОбРАбОТКА ДАННЫХ ПЛЕЙЛИСТА =============================================
//================================================================================== 
//==================================================================================
//==================================================================================     
         //IR.Log("Данные плейлиста");
         var JSONObject2 = JSONObjectTemp;
         
         //var PlaylistArray = [];
         // Массив [[АРТИСТ][НАЗВАНИЕ ПЕСНИ][АЛЬБОМ][ДЛИТЕЛЬНОСТЬ ПЕСНИ][ПОЗИЦИЯ В СПИСКЕ][ID]]
         var PlaylistArtist, PlaylistTitle, PlaylistAlbum, PlaylistPos, PlaylistID;
      
         //Элементы плейлиста
         var Playlist = JSONObject2;
         PlaylistLength = JSONObject2.length;
         IR.SetVariable("Drivers."+DeviceName+".Amati_Playlist length",PlaylistLength);
         //IR.Log("PlaylistLength = " + PlaylistLength);
         //Данные первого вхождения 
         for(i=0;i<PlaylistLength;i++)
         {
            if (JSONObject2[i].Artist) 
               PlaylistArtist = JSONObject2[i].Artist;   
            else
               PlaylistArtist = "Неизвестный артист";
            PlaylistArray[6*i] = PlaylistArtist; 
            //IR.Log("PlaylistArtist = " + PlaylistArrayElement[0]);
            
            if (JSONObject2[i].Title) 
               PlaylistTitle = JSONObject2[i].Title;   
            else
               PlaylistTitle = "Неизвестная композиция";
            PlaylistArray[6*i+1] = PlaylistTitle;
            //IR.Log("PlaylistTitle = " + PlaylistArrayElement[1]);
         
            if (JSONObject2[i].Album) 
               PlaylistAlbum = JSONObject2[i].Album;   
            else
               PlaylistAlbum = "Неизвестный альбом";
            PlaylistArray[6*i+2] = PlaylistAlbum;
            //IR.Log("Album = " + PlaylistArrayElement[2]);
         
            if (JSONObject2[i].Time) 
               PlaylistTime = JSONObject2[i].Time;   
            else
               PlaylistTime = "0:00:00";
            PlaylistArray[6*i+3] = PlaylistTime;
            //IR.Log("PlaylistTime = " + PlaylistArrayElement[3]);
         
            PlaylistPos = JSONObject2[i].Pos;
            PlaylistArray[6*i+4] = PlaylistPos; 
            PlaylistID = JSONObject2[i].Id;
            PlaylistArray[6*i+5] = PlaylistID;
            //IR.Log("Pos:Id = " + PlaylistArray[6*i+4] + ":" + PlaylistArray[6*i+5]);
         }
      }
      else
      {
//==================================================================================
//==================================================================================
//==================================================================================
//========= ОбРАбОТКА ДАННЫХ ФАЙЛОВОЙ СИСТЕМЫ ======================================
//================================================================================== 
//==================================================================================
//==================================================================================        
         IR.Log("Данные файловой системы");
         var JSONObject2 = JSONObjectTemp;
         
         //var FilesystemArray = [];
         // Массив [[АРТИСТ][НАЗВАНИЕ ПЕСНИ][АЛЬБОМ][ДЛИТЕЛЬНОСТЬ ПЕСНИ][ПОЗИЦИЯ В СПИСКЕ][ID]]
         var FilesystemArtist, FilesystemTitle, FilesystemAlbum, FilesystemTime;
      
         //Элементы плейлиста
         var Filesystem = JSONObject2;
         FilesystemLength = Filesystem.length;
         //IR.Log("FilesystemLength = " + FilesystemLength);
         IR.SetVariable("Drivers."+DeviceName+".Amati_Filesystem length",FilesystemLength);
         //Данные первого вхождения 
         for(i=0;i<FilesystemLength;i++)
         {
            if (JSONObject2[i].directory) 
               FilesystemArray[i] = JSONObject2[i].directory;   
            //else
               //FilesystemArray[i] = "ХЗ что это";
            //IR.Log("Элемент ФС ["+i+"] = " + FilesystemArray[i]);
         } 


      
      }
      
      
   });
}

